cls
echo off
echo This batch file will set up a run of CFFFCOMB, a Continued Fraction
echo     Factor with Find COMBination implementation, for you.
echo 
echo If you don't have any test composites in mind for me, may I suggest some?
echo Try 833,780,449,644,887,xxx
echo     (where xxx is 917 or 909 or 897 or 891 or 881 or 869).
echo Or, a little harder, try 12,602,997,014,870,997,xxx
echo     (where xxx is 853 or 863 or 869 or 871 or 899 or 907).
echo Or, 1122334455667788998877665544332211  (which has far too many digits)
echo     and 9988776655443322112233445566778899  are thrills because they are
echo     special cases.
echo 
echo First, enter some numbers you'd like factored, one to a line;
echo     finish with Ctrl-Z and return.
if exist nsin.fil erase nsin.fil
copy con nsin.fil
echo Thank you, we'll get to work shortly.
echo This package is copyrighted by KSU Research Foundation, KSU, Manhattan KS 66506
pause
cls
erase primes.fil
echo Output appears in OUTFILE.FIL as well as on the screen.
echo 
echo Note that the factors found are not necessarily prime ....
echo    to get prime factors, input found factors to be further
echo    factored or pronounced prime.  Pronouncements of primality are based on
echo    6 successive probabilistic primality tests, so are correct with odds
echo    greater than 4000:1.
echo 
echo We're going to run this with a limited set of primes.  If you are going
echo     to factor numbers over 21 digits, you may want to alter the following
echo     'copy' lines, so that the larger file of primes will be used.
echo 
echo on
copy primes21.fil primes.fil
echo off
echo rem copy primes29.fil primes.fil
echo 
echo That's settled.  Ready for a screen of orienting information?
pause
cls
echo You'll see a lot of action:
echo 
echo We give you action to keep you interested and impart a sense of pace.
echo    If you put a prime in, we don't try to factor it.
echo    Small factors are eliminated in a lump before we get serious later.
echo       (You can factor the lumps by hand; maximum factor is 103.)
echo    If that leaves a prime, we don't try to factor it further.
echo 
echo    There is a pause while a good value of k is found for this composite.
echo 
echo    Next, see the set of primes actually used as the basis for factoring.
echo       Notice m, the number of primes in the basis.  (K is of little interest.)
echo 
echo    Watch the series of 'hits' discovered by the continued fraction process.
echo       Each has a base 66536 number, a series of exponents of the primes in
echo       use, and a parenthesized counter of the number of 'hits' gathered.
echo       The factor will be found before the counter reaches m+2.
echo 
echo    When an even linear combination arises, there'll either be a factoring
echo    reported, or a notice of an X=Y or an X+Y=N glitch before going on.
echo    A total failure to factor gives a 'Continued Fraction Cycled' message.
echo 
echo You can stop proceedings at any output by entering Ctrl-Break.
pause
cls
echo     Here we go ........................................
cfffcomb
