{ MPI - Multiple Precision Positive Integer Arithmetic Package   }
{ Copyright 1989, KSU Research Foundation, Manhattan KS  66506   }
{ License granted to copy, but not for sale or profit   }
 program luclehmr;
  uses crt;
  {$L mpifacel}
  const regmax = 629;
  {625 words will hold 10,000 bits -- 630 is space for q=10000+}
  {PR of MPI is double precision and will hold the L**2 value}
  type
   c4 = packed array[1..4] of char;
   register = array[0..regmax] of word;
   ctrlptr = ^ctrl;
   regptrtyp = ^register;
   ctrl = record
    operation: c4;
    ptr1,ptr2: regptrtyp;
    ln1,ln2: word
   end;
  var
   argsdescr,holddescr,lswdescr: ctrl;
   argsptr: ctrlptr;
   oldspot:regptrtyp;
   capl: register;
   range: array[1..20] of word;
   one,two: array[1..2] of word;
   powertwo: array[0..15] of word;
   bwd,k,qby16,qmod16,qguard,q,qmax,tempword: word;
    {because will address qguard word in MPI call}
   i,j,npor,mpr,mnpr: byte;
   porc,result: char;
  function pptface(a: ctrlptr): char; external;
  function mpiface(a: ctrlptr): ctrlptr;  external;
  procedure makecont(cptr:ctrlptr; a1,a2:regptrtyp; l1,l2:word; op:c4);
   begin
    cptr^.ptr1 := a1;
     cptr^.ptr2 := a2;
     cptr^.ln1  := l1;
     cptr^.ln2  := l2;
     cptr^.operation := op
   end;
  procedure moveit(into,from:regptrtyp; l:word);
   var i:word;
   begin
    for i := 0 to l do into^[regmax-l+i] := from^[i]
   end;
  begin
   k := 1;
   for i := 0 to 15 do begin
    powertwo[i] := k;
    if i < 15 then k := k+k
   end;
   argsptr := addr(argsdescr);
   qguard := 0;
    clrscr;
     range[1] := 3; range[2] := 613;{3,5,7,13,17,19,31,61,89,107,127,521,607}
     range[3] := 1261; range[4] := 1287; {1279}
      range[5] := 2163; range[6] := 2211; {2203}
      range[7] := 2271; range[8] := 2291; {2281}
     {these ranges isolate the values of n for which Mersenne numbers are prime}
     range[9] := 3205; range[10] := 3227; {3217}
      range[11] := 4243; range[12] := 4259; {4253}
       range[13] := 4411; range[14] := 4445; {4423}
       range[15] := 9663; range[16] := 9695; {9689}
       range[17] := 9931; range[18] := 9965; {9941}
       range[19] := 11179; range[20] := 11241; {11213}
   writeln('non-prime','q':20,'Mersenne':17,'k':18);
    writeln('odd numbers','prime':23,'non-prime':20);
   npor := 4; mpr := 4; mnpr := 4;
   j := 1;
   one[1]:=0; one[2]:=1; two[1]:=0; two[2]:=2;
   while j < 20 do begin
    {pick out this range's limits to control processing time}
    q := range[j];
    qmax := range[j+1];
    j := j+2;
    while q<=qmax do begin
     result := 'P';
     for i:=1 to 3 do begin
      makecont(argsptr,addr(qguard),addr(qguard),1,1,'PROB');
      porc := pptface(argsptr);
      if porc = 'C' then result := 'C'
     end;
     if result = 'P' then begin
      gotoxy(30,1); write(q:5);
      {bit-addressing variables}
       qby16 := q div 16;
       if qby16 >= regmax then begin
        gotoxy(1,21);
         write(q,' will give too large a Mersenne number. Terminating.');
         halt
       end;
       qmod16 := q mod 16;
      bwd := regmax-qby16;{subscript of boundary word between LSW & MSW}
      {L[0] := 4} capl[regmax-1]:=0; capl[regmax] := 4;
      holddescr.ptr1:=addr(capl[regmax-1]);
      holddescr.ln1:=1;
      {invariant is that holddescr.op1 describes L[n] in L-register}
      for k:= 3 to q do begin
       {form L**2 from L}
        makecont(argsptr,holddescr.ptr1,holddescr.ptr1,holddescr.ln1,holddescr.ln1,'MULT');
         argsptr := mpiface(argsptr);
         holddescr := argsdescr;
       {holddescr points temporarily to MPIPR contents}
       {subtract 2 to get L**2 - 2}
        tempword := holddescr.ptr1^[1];
        makecont(argsptr,holddescr.ptr1,addr(two[1]),holddescr.ln1,1,'SUBT');
        argsptr := mpiface(argsptr);
       {no need to change holddescr -- unlikely to borrow from MSW}
       gotoxy(70,1); write(k:5);
       {manipulate the Least and Most Signifcant Words separately to form (L**2-2) MOD 2**q-1}
        {move LSWs of L**2-2 back into the L-register}
         lswdescr.ln1 := qby16+1;
         lswdescr.ptr1 := addr(capl[bwd-1]);
         if argsdescr.ln1<lswdescr.ln1 then begin
          {this arises until L**2 achieves a length of qby16+1}
          lswdescr.ptr1 := addr(lswdescr.ptr1^[lswdescr.ln1-argsdescr.ln1]);
          lswdescr.ln1 := argsdescr.ln1
         end;
         moveit(addr(capl),addr(holddescr.ptr1^[holddescr.ln1-lswdescr.ln1]),lswdescr.ln1);
         capl[bwd-1] := 0; {guard word for LSW portion}
        if holddescr.ln1>=qby16 then begin
         {zero the too-significant bits of the LSW portion}
          capl[bwd] := capl[bwd] MOD powertwo[qmod16];
           {if leading bit-strip exposes lots of zeroes, renormalize}
            while lswdescr.ptr1^[1] = 0 do begin
             lswdescr.ptr1 := addr(lswdescr.ptr1^[1]);
             lswdescr.ln1 := pred(lswdescr.ln1)
            end;
         {leftshift MSWs of L**2-2 to achieve word alignment}
          {q is odd ==> qmod16 is odd ==> 16-qmod16 is odd (non-zero)}
           makecont(argsptr,holddescr.ptr1,addr(powertwo[16-qmod16]),holddescr.ln1-qby16,1,'SHIF');
          oldspot := argsdescr.ptr1;
          argsptr := mpiface(argsptr);
          {if L**2 isn't yet qby16+1 words big, skip this folderol}
          if (holddescr.ln1>qby16+1) or ((holddescr.ln1=qby16+1) and (argsdescr.ptr1<>oldspot)) then begin
           argsdescr.ln1 := argsdescr.ln1 - 1;
            {this was a SHIFTLEFT to achieve a right shift; drop trailing word}
           {that left shift could have overflowed so holddescr needs revision}
           holddescr := argsdescr;
           {add MSW to LSW in L-register}
           makecont(argsptr,lswdescr.ptr1,holddescr.ptr1,lswdescr.ln1,holddescr.ln1,'ADDE');
           argsptr := mpiface(argsptr);
           holddescr := argsdescr;{resets invariant}
           {check for carry and do any needed fixup}
           if capl[bwd] >= powertwo[qmod16] then begin
            {there cannot be any carry across word boundary}
            capl[bwd] := capl[bwd] mod powertwo[qmod16];
            makecont(argsptr,holddescr.ptr1,addr(one[1]),holddescr.ln1,1,'ADDE');
            argsptr := mpiface(argsptr);
            holddescr := argsdescr;
            {if that carry was followed by many zeroes, must renormalize}
            while holddescr.ptr1^[1]=0 do begin
             holddescr.ln1 := pred(holddescr.ln1);
             holddescr.ptr1 := addr(holddescr.ptr1^[1])
            end;
           end;
          end
          else holddescr := lswdescr
        end
        else holddescr := lswdescr
       {now holddescr is back to pointing to L in L-register (the invariant)}
      end;
      {is the result zero or (equivalently) 2**q - 1?}
      if ((holddescr.ln1 = qby16+1) and (holddescr.ptr1^[1] = powertwo[qmod16])) then begin
       gotoxy(30,mpr); write(q:5);
        mpr:=mpr+1; if mpr>20 then mpr:=4
      end
      else if (holddescr.ptr1^[1] = powertwo[qmod16]-1) then begin
       makecont(argsptr,holddescr.ptr1,addr(one[1]),holddescr.ln1,1,'ADDE');
        argsptr := mpiface(argsptr);
       if argsdescr.ptr1^[1]=powertwo[qmod16] then begin
        gotoxy(30,mpr); write(q:5);
         mpr:=mpr+1; if mpr>20 then mpr:=4
       end
       else begin
        gotoxy(50,mnpr);write(q:5);
         mnpr:=mnpr+1; if mnpr>20 then mnpr:=4
       end
      end
      else begin
       gotoxy(50,mnpr);write(q:5);
        mnpr:=mnpr+1; if mnpr>20 then mnpr:=4
      end
     end
     else begin
      gotoxy(1,npor); write(q:5);
       npor:=npor+1; if npor>20 then npor:=4
     end;
     q := q + 2
    end
   end
  end.
